/* Computes the smallest prime larger than the initial value
   of N. */
#include <stdio.h>
#include <gmp.h>

int main()
{
  mpz_t N, t, sqrtN;
  int isprime;

  /* Initialize GMP integer variables */
  mpz_init_set_str(N, "10000000000000", 0);
  mpz_init(t);
  mpz_init(sqrtN);

  /* Iterate over N. */
  while(1) {
    mpz_set_si(t, 2);   /* t = 2 */
    isprime = 1;
    mpz_sqrt(sqrtN, N);
    /* Iterate over t, the potential divisor. */
    while(mpz_cmp(t, sqrtN) <= 0) { /* t <= sqrtN */
      if (mpz_divisible_p(N, t)) {
	isprime = 0;
	break;
      }
      mpz_add_ui(t, t, 1);  /* t = t + 1 */
    }
    if (isprime)
      break;
    mpz_add_ui(N, N, 1);    /* N = N + 1 */
  }
  printf("Prime found:");
  mpz_out_str(stdout, 10, N);
  printf("\n");
}
